// TidyOptions.h : Declaration of the CTidyOptions

#ifndef __TIDYOPTIONS_H_
#define __TIDYOPTIONS_H_

#include "resource.h"       // main symbols
#include "../TidyGUI/TidyProxy.h"

//-------------------------------------------------------------------
// CTidyOptions
class ATL_NO_VTABLE CTidyOptions : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTidyOptions, &CLSID_TidyOptions>,
	public ISupportErrorInfo,
	public IDispatchImpl<ITidyOptions, &IID_ITidyOptions, &LIBID_TidyCOM>
{
public:
	CTidyOptions() { }

	HRESULT FinalConstruct();
	void FinalRelease();

private:	// variables
	CTidyProxy* m_pTidyProxy;

public:
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// interface ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// interface ITidyOptions
	STDMETHOD(SetPtr)(long val);

	STDMETHOD(Load)(BSTR configFile);
	STDMETHOD(Reset)();
	// Markup
	STDMETHOD(get_Doctype)(BSTR *pVal);
	STDMETHOD(put_Doctype)(BSTR newVal);
	STDMETHOD(get_TidyMark)(VARIANT_BOOL *pVal);
	STDMETHOD(put_TidyMark)(VARIANT_BOOL newVal);
	STDMETHOD(get_HideEndtags)(VARIANT_BOOL *pVal);
	STDMETHOD(put_HideEndtags)(VARIANT_BOOL newVal);
	STDMETHOD(get_EncloseText)(VARIANT_BOOL *pVal);
	STDMETHOD(put_EncloseText)(VARIANT_BOOL newVal);
	STDMETHOD(get_EncloseBlockText)(VARIANT_BOOL *pVal);
	STDMETHOD(put_EncloseBlockText)(VARIANT_BOOL newVal);
	STDMETHOD(get_NewEmptyTags)(BSTR *pVal);
	STDMETHOD(put_NewEmptyTags)(BSTR newVal);
	STDMETHOD(get_NewInlineTags)(BSTR *pVal);
	STDMETHOD(put_NewInlineTags)(BSTR newVal);
	STDMETHOD(get_NewBlocklevelTags)(BSTR *pVal);
	STDMETHOD(put_NewBlocklevelTags)(BSTR newVal);
	STDMETHOD(get_NewPreTags)(BSTR *pVal);
	STDMETHOD(put_NewPreTags)(BSTR newVal);
	// Cleanup
	STDMETHOD(get_Clean)(VARIANT_BOOL *pVal);
	STDMETHOD(put_Clean)(VARIANT_BOOL newVal);
	STDMETHOD(get_DropFontTags)(VARIANT_BOOL *pVal);
	STDMETHOD(put_DropFontTags)(VARIANT_BOOL newVal);
	STDMETHOD(get_LogicalEmphasis)(VARIANT_BOOL *pVal);
	STDMETHOD(put_LogicalEmphasis)(VARIANT_BOOL newVal);
	STDMETHOD(get_DropEmptyParas)(VARIANT_BOOL *pVal);
	STDMETHOD(put_DropEmptyParas)(VARIANT_BOOL newVal);
	STDMETHOD(get_Word2000)(VARIANT_BOOL *pVal);
	STDMETHOD(put_Word2000)(VARIANT_BOOL newVal);
	STDMETHOD(get_FixBadComments)(VARIANT_BOOL *pVal);
	STDMETHOD(put_FixBadComments)(VARIANT_BOOL newVal);
	STDMETHOD(get_FixBackslash)(VARIANT_BOOL *pVal);
	STDMETHOD(put_FixBackslash)(VARIANT_BOOL newVal);
	STDMETHOD(get_AltText)(BSTR *pVal);
	STDMETHOD(put_AltText)(BSTR newVal);
	// XML
	STDMETHOD(get_InputXml)(VARIANT_BOOL *pVal);
	STDMETHOD(put_InputXml)(VARIANT_BOOL newVal);
	STDMETHOD(get_OutputXml)(VARIANT_BOOL *pVal);
	STDMETHOD(put_OutputXml)(VARIANT_BOOL newVal);
	STDMETHOD(get_OutputXhtml)(VARIANT_BOOL *pVal);
	STDMETHOD(put_OutputXhtml)(VARIANT_BOOL newVal);
	STDMETHOD(get_AddXmlDecl)(VARIANT_BOOL *pVal);
	STDMETHOD(put_AddXmlDecl)(VARIANT_BOOL newVal);
	STDMETHOD(get_AssumeXmlProcins)(VARIANT_BOOL *pVal);
	STDMETHOD(put_AssumeXmlProcins)(VARIANT_BOOL newVal);
	STDMETHOD(get_AddXmlSpace)(VARIANT_BOOL *pVal);
	STDMETHOD(put_AddXmlSpace)(VARIANT_BOOL newVal);
	// Encoding
	STDMETHOD(get_CharEncoding)(CharEncoding *pVal);
	STDMETHOD(put_CharEncoding)(CharEncoding newVal);
	STDMETHOD(get_NumericEntities)(VARIANT_BOOL *pVal);
	STDMETHOD(put_NumericEntities)(VARIANT_BOOL newVal);
	STDMETHOD(get_QuoteMarks)(VARIANT_BOOL *pVal);
	STDMETHOD(put_QuoteMarks)(VARIANT_BOOL newVal);
	STDMETHOD(get_QuoteNbsp)(VARIANT_BOOL *pVal);
	STDMETHOD(put_QuoteNbsp)(VARIANT_BOOL newVal);
	STDMETHOD(get_QuoteAmpersand)(VARIANT_BOOL *pVal);
	STDMETHOD(put_QuoteAmpersand)(VARIANT_BOOL newVal);
	// Layout
	STDMETHOD(get_Indent)(IndentScheme *pVal);
	STDMETHOD(put_Indent)(IndentScheme newVal);
	STDMETHOD(get_IndentSpaces)(long *pVal);
	STDMETHOD(put_IndentSpaces)(long newVal);
	STDMETHOD(get_Wrap)(long *pVal);
	STDMETHOD(put_Wrap)(long newVal);
	STDMETHOD(get_TabSize)(long *pVal);
	STDMETHOD(put_TabSize)(long newVal);
	STDMETHOD(get_IndentAttributes)(VARIANT_BOOL *pVal);
	STDMETHOD(put_IndentAttributes)(VARIANT_BOOL newVal);
	STDMETHOD(get_WrapAttributes)(VARIANT_BOOL *pVal);
	STDMETHOD(put_WrapAttributes)(VARIANT_BOOL newVal);
	STDMETHOD(get_WrapScriptLiterals)(VARIANT_BOOL *pVal);
	STDMETHOD(put_WrapScriptLiterals)(VARIANT_BOOL newVal);
	STDMETHOD(get_WrapAsp)(VARIANT_BOOL *pVal);
	STDMETHOD(put_WrapAsp)(VARIANT_BOOL newVal);
	STDMETHOD(get_WrapJste)(VARIANT_BOOL *pVal);
	STDMETHOD(put_WrapJste)(VARIANT_BOOL newVal);
	STDMETHOD(get_WrapPhp)(VARIANT_BOOL *pVal);
	STDMETHOD(put_WrapPhp)(VARIANT_BOOL newVal);
	STDMETHOD(get_BreakBeforeBr)(VARIANT_BOOL *pVal);
	STDMETHOD(put_BreakBeforeBr)(VARIANT_BOOL newVal);
	STDMETHOD(get_UppercaseTags)(VARIANT_BOOL *pVal);
	STDMETHOD(put_UppercaseTags)(VARIANT_BOOL newVal);
	STDMETHOD(get_UppercaseAttributes)(VARIANT_BOOL *pVal);
	STDMETHOD(put_UppercaseAttributes)(VARIANT_BOOL newVal);
	STDMETHOD(get_LiteralAttributes)(VARIANT_BOOL *pVal);
	STDMETHOD(put_LiteralAttributes)(VARIANT_BOOL newVal);
	// Operation
	STDMETHOD(get_Markup)(VARIANT_BOOL *pVal);
	STDMETHOD(put_Markup)(VARIANT_BOOL newVal);
	STDMETHOD(get_Quiet)(VARIANT_BOOL *pVal);
	STDMETHOD(put_Quiet)(VARIANT_BOOL newVal);
	STDMETHOD(get_ShowWarnings)(VARIANT_BOOL *pVal);
	STDMETHOD(put_ShowWarnings)(VARIANT_BOOL newVal);
	STDMETHOD(get_Split)(VARIANT_BOOL *pVal);
	STDMETHOD(put_Split)(VARIANT_BOOL newVal);
	STDMETHOD(get_KeepTime)(VARIANT_BOOL *pVal);
	STDMETHOD(put_KeepTime)(VARIANT_BOOL newVal);
	STDMETHOD(get_ErrorFile)(BSTR *pVal);
	STDMETHOD(put_ErrorFile)(BSTR newVal);
	STDMETHOD(get_GnuEmacs)(VARIANT_BOOL *pVal);
	STDMETHOD(put_GnuEmacs)(VARIANT_BOOL newVal);

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DECLARE_NO_REGISTRY()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTidyOptions)
	COM_INTERFACE_ENTRY(ITidyOptions)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()
};

//-------------------------------------------------------------------
#endif //__TIDYOPTIONS_H_
